#include "particle.h"

Particle::Particle () {

    mPos = ofxVec2f ( ofRandomWidth (), ofRandomWidth () );
    setup ();

}

//--------------------------------------------------------------
Particle::Particle ( ofxVec2f pos ) {

    mPos = pos;
    setup ();

}

//--------------------------------------------------------------
Particle::~Particle () {
    //cout << "Particle destructed" << endl;
}

//--------------------------------------------------------------
void Particle::setup () {

    mVel = ofxVec2f ( ofRandomf (), ofRandomf () ) * 10;
    mSize = 5.0;

    mAge = 0;
    mLifetime = 60;
    mDead = false;
}

//--------------------------------------------------------------
void Particle::update () {
    mPos += mVel;

    mAge++;
    if (mAge > mLifetime)
        mDead = true;
}

//--------------------------------------------------------------
void Particle::draw () {
    ofSetColor ( 0xFFFFFF );
    ofFill ();
    ofCircle ( mPos.x, mPos.y, mSize * ( (float) ( mLifetime - mAge ) / (float) mLifetime ) );
}

//--------------------------------------------------------------
bool Particle::isOffscreen () {
    return ( mPos.x < 0 || mPos.y < 0 || mPos.x > ofGetWidth() || mPos.y > ofGetHeight() );
}
